'freebasic
rem *****************************************
rem * fbkiss.bas                            *
rem * A simple KISS doll player             *
rem * Written by Deckard of AtD 10 Aug 2022 *
rem * http://www.atd-group.narod.ru         *
rem *****************************************
#include "Windows.bi"
#include "win/mmsystem.bi"

deflng a-z
' sprite type
type sprtype
    hid as long
    x as long
    y as long
    sx as long
    sy as long
    img as ulong ptr
end type
' sprite coordinates
dim shared x0(256,10)
dim shared y0(256,10)
dim shared xx(256,10)
dim shared yy(256,10)

' offset of mouse position in sprite
dim shared dx(256)
dim shared dy(256)
dim sptname$
' a number of sprites
dim shared maxspt
' sprite array
dim shared s(256) as sprtype

' Is file n$ exist ?
function exists(n$) as long
re=open(n$,for input,as #9)
close #9
if re=0 then exists=-1 else exists=0
end function

' Load MP3 file n$ to sound number i (i=from 1 to 15)
sub sndload(i,n$)
dim cm as zstring*256
if not exists(n$) then
  print n$;" - file not found":sleep:end
end if
cm="open "+n$+" type MpegVideo alias SND"+hex$(i)
mciSendString(cm,"",0,0)
end sub

' Play a sound i
sub sndplay(i)
dim cm as zstring*256
cm="play SND"+hex$(i)+" from 0"
mciSendString(cm,"",0,0) 
end sub

' Is one of n sounds playing ?
function SndPlaying(n)
dim cm as zstring*256
dim re as zstring*256
for i=1 to n
cm="status SND"+hex$(i)+" mode"
mciSendString(cm,re,255,0)
if re="playing" then SndPlaying=-1:exit function
next i
SndPlaying=0
end function

' Load bmp sprite n$ to sprite number i
sub sptload(i,n$)
nf$=n$+".bmp"
if not exists(nf$) then
  print nf$;" - file not found":sleep:end
end if
open nf$ for binary as #1
' Read image size from BMP file
get #1,1+&h12,s(i).sx
get #1,,s(i).sy
close #1
s(i).img=imagecreate(s(i).sx,s(i).sy)
bload nf$,s(i).img
end sub

' What sprite collides with mouse pointer ?
function collide(mx,my) as long
collide=0
' if mouse pointer is out of window
if mx=-1 or my=-1 then exit function
' loop on all i
for i=1 to maxspt
  if s(i).hid=0 then dx(i)=mx-s(i).x:dy(i)=my-s(i).y
next i
' exit function occurs from loop
for i=1 to maxspt
if s(i).hid=0 then
    if (dx(i)>=0) and (dx(i)<s(i).sx) and (dy(i)>=0) and (dy(i)<s(i).sy) then
' &hff00ff is a transparent color (no collision)
        d=point(dx(i),dy(i),s(i).img):if (d and &h00ffffff)<>&hff00ff then collide=i:exit function
    end if
end if
next i
end function

'main program
' Set 32bit 2page screen
screenres 640,480,32,2
width 80,30
' data file
fi$="kissdata.dk"
er=open(fi$,for input,as #2)
if er then
  print fi$;" - file not found":sleep:end
end if
maxspt=1
' directory of sprites and sounds
line input #2,dirf$
line input #2,a$
do
i=maxspt
' coordinates of sprites
for c=0 to 10
x0(i,c)=val(mid$(a$,1+8*c,3))
y0(i,c)=val(mid$(a$,5+8*c,3))
xx(i,c)=x0(i,c)
yy(i,c)=y0(i,c)
next c
' BMP filename
sptname$=mid$(a$,1+88)
'print sptname$
sptload i,dirf$+sptname$
maxspt=maxspt+1
line input #2,a$
' sign "the end of sprite list"
loop while (a$<>"END")

maxspt=maxspt-1
line input #2,dirf$
' number of clothes sets
line input #2,a$:maxgroup=val(a$):if maxgroup=0 then maxgroup=1
' x and y offsets for all sprites (999 - invisible sprite)
line input #2,a$:xbase=val(a$)
line input #2,a$:ybase=val(a$)
for i=1 to maxspt:for c=0 to 9
  if x0(i,c)<>999 then
    x0(i,c)=x0(i,c)+xbase
    y0(i,c)=y0(i,c)+ybase
    xx(i,c)=x0(i,c)
    yy(i,c)=y0(i,c)
  end if
next c:next i
' load MP3 sounds
while not eof(2)
    line input #2,a$
    if instr(a$,".mp3") then maxsnd=maxsnd+1:sndload(maxsnd,dirf$+a$)
wend
close #2
'=== main loop ===
' current dress set
c=0
pg=0
do
' swap active and visible video pages
pg=1-pg:screenset pg,1-pg
' exit on any key press
if inkey$<>"" then end
' fill sprite coordinates array
for i=1 to maxspt
if x0(i,c)=999 then
  s(i).hid=-1
else
  s(i).hid=0:s(i).x=x0(i,c):s(i).y=y0(i,c)
end if
next i
' clear screen by background color
line(0,0)-(639,479),rgb(0,255,0),bf

' draw all sprites using "transparent color" method
for i=maxspt to 1 step -1
if s(i).hid=0 then put(s(i).x,s(i).y),s(i).img,trans
next i
' poll a mouse
getmouse mx,my,,mb
mkold=mk
mkrold=mkr
if mb>=0 then
mk=(mb and 1)
mkr=(mb and 2)
end if
' if left button not pressed or rubber effect then ...
if mk=0 or rubber<>0 then
  r=collide(mx,my)
' some elements of clothes (with the same mark) have the same coordinates
  if r then mark=x0(r,10)
'  locate 1,1:print using "###";r;
for i=1 to maxspt
if s(i).hid=0 then
' rubber effect
if y0(i,10) then
   move=(xx(i,c)<>x0(i,c) or yy(i,c)<>y0(i,c))
   if xx(i,c)<x0(i,c) then x0(i,c)=x0(i,c)-1
   if xx(i,c)>x0(i,c) then x0(i,c)=x0(i,c)+1
   if yy(i,c)<y0(i,c) then y0(i,c)=y0(i,c)-1
   if yy(i,c)>y0(i,c) then y0(i,c)=y0(i,c)+1
   if move and (xx(i,c)=x0(i,c) and yy(i,c)=y0(i,c)) then y0(i,10)=y0(i,10)+(y0(i,10)<>0):flag=-1
end if
end if
next i
end if
' drag sprite by mouse
if mk<>0 and r<>0 and rubber=0 then
for i=1 to maxspt
  if s(i).hid=0 and x0(i,10)=mark and y0(i,10)<10 then
      x0(i,c)=mx-dx(i)
      y0(i,c)=my-dy(i)
      if y0(i,10) then
      if mk>mkold and SndPlaying(maxsnd)=0 then SndPlay(1+int(maxsnd*rnd))
' if player tries to drag "prohibited object" too far (panties for example.
' What in the hell is this code intended for ?)
      if abs(xx(i,c)-x0(i,c))>20 or abs(yy(i,c)-y0(i,c))>20 then rubber=-1   
      end if
  end if    
next i    
end if
' switch off rubber effect
if flag<>0 then rubber=0:flag=0
' if right button clicked then switch a dress set
if mkr>0 and mkrold=0 then c=(c+1) mod maxgroup
sleep 20
loop
end
